/* --------------- ffmpegHigh --------------- */
/* Written and (c)by Rmy DODIN               */
/* Written date: 20090427                     */
/* Update  date: 20090427 - 11pm              */
/* Update  date: 20090428 -  4am              */
/*   1 / 0 at end of cmd enables rc details   */
/* Update  date: 20090428 -  7pm              */
/*   - inputfile xxxx.dlh can be used         */
/*     file includes a list of DLLs           */
/*     e.g. out of dir *.dll /B-D             */
/*   - Changed to process Handle in HEX code  */
/* Update  date: 20090429 -  2am              */
/*   - added handle query before free         */ 
/* (user specified modules or no handle file) */ 
/* Update  date: 20090430 -  9am              */
/* Update  date: 20090502 - 11pm              */
/* Update  date: 20090503 - 11pm              */
/* ------------------------------------------ */
/* Revision: 0.9.2                            */
/* syntax: option (-l,-u,-q,-!, -h) dllname   */ 
/* Do not remove these top lines              */
/* ------------------------------------------ */   
/* -l to load modules                         */
/* -u to unload modules                       */
/* -q to query existing handle                */
/* -h -? to display the help                  */
/* -! to unlock by unlock option if available */
/* ------------------------------------------ */
/* Prerrrequisit: RXU.DLL                     */
/*------------------------------------------- */
/* loading required functions                 */
/* ------------------------------------------ */
If rxfuncquery('SysLoadFuncs') then do
	Call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
	Call SysLoadFuncs
End
If rxfuncquery('RxLoadModule') | rxfuncquery('RxFreeModule') | rxfuncquery('RxQueryModuleHandle') | rxfuncquery('RxQueryModuleName') then do
	Call RxFuncAdd 'RxLoadModule','rxu','RxLoadModule'
	Call RxFuncAdd 'RxFreeModule','rxu','RxFreeModule'
	Call RxFuncAdd 'RxQueryModuleName','rxu','RxQueryModuleName'
	Call RxFuncAdd 'RxQueryModuleHandle','rxu','RxQueryModuleHandle'
End
Parse Upper Source sys calltype filespec'.'ext
Parse arg var1 var2 var3 .
option='';single_dll='';fulllog='';dll_path='';abort_load=0
path_pgm=substr(filespec,1,Lastpos('\',filespec)-1)
If strip(var2\='') then single_dll=strip(translate(var2,' ','"'))
If var3<>1 then option=''
Else option=var3
If strip(var1\='') then do
	option=var1
	If option='-c' then option='-l'
	If (option='-?')|(option='-h') then Call help_messages
	Else Call ffmpeghigh
End
Call directory path_pgm
Call closing_message2
say '   Use -? or -h for help information' 
return

ffmpeghigh:
If rxfuncquery('RxLoadModule') then do
   Say '  * Error: Missing RXU.DLL or enable to load its functions'
   return
End  
/* ------------------------------------------ */
/*         Number of DLL to handle            */
/* ------------------------------------------ */ 
Dll_list.0 =13
Dll_Uhnd.0 = 0
bypass_popup=0

/* ----------- Liste of DLLs ---------------- */

Dll_list.1 ='X264150'
Dll_list.2 ='LIBVPX5'
Dll_list.3 ='SDL2'
Dll_list.4 ='POSTPR55'
Dll_list.5 ='AVDEVI58'
Dll_list.6 ='SWRESA3'
Dll_list.7 ='SWSCAL5'
Dll_list.8 ='AVFILT7'
Dll_list.9 ='AVCODE58'
Dll_list.10='AVFORM58'
Dll_list.11='AVUTIL56'
Dll_list.12='VLCCORE'
Dll_list.13='VLC'


/* --------------- End of list -------------- */
/* -------------- code  followw ------------- */

Call start_messages

If fulllog=2 then bypass_popup=1
If (fullog<0)|(fulllog>1) then fulllog=0
If single_dll\='' then do
   If (single_dll=1)|(single_dll=0) then do
	fulllog=single_dll
	single_dll=''
   End
   Else do			
   If ((pos('.DLL',translate(single_dll))=0)|(pos('*',single_dll)>0)|(pos('.',single_dll)=0))&(pos('.DLH',translate(single_dll))=0) then do	
	Say ' ' 
	Say '  Seems not to be a DLL ! (wildcard not allowed and must end with ".dll")'
	Say ' '
	return
   End
   If pos('.DLH',translate(single_dll))>0 then do
	Call read_dll_file
	If abort_load=1 then return
   End
   Else do
	single_dll=strip(translate(single_dll,' \','"/'))
	If pos('\',single_dll,1)>0 then do
		dll_path=substr(single_dll,1,Lastpos('\',single_dll)-1)
		single_dll=substr(single_dll,Lastpos('\',single_dll)+1)
		Say '   Dll(s) path : '||dll_path
		path_pgm = directory()
		new_ffmpegdir = directory(dll_path)
               	If translate(new_ffmpegdir) = strip(translate(dll_path)) then Say '   Path to DLL(s) found, process will continue and try loading DLL(s)'
               	Else do
			Say "   Can't find the speficfied path : "||new_ffmpegdir||'!. Aborting process...'  
			abort_load=1
			Call directory path_pgm
		End
		If abort_load=1 then return
	End
   	Say '   User specified DLL to handle : '||single_dll
   	Dll_list.0=1
   	Dll_list.1=substr(single_dll,1,pos('.',single_dll,1)-1)
   End
   End
End

If option='-q' then do
	Say '   Dynamic handle search (query) by module name'
	Say '   number of query to proceed: '||Dll_list.0
	Say ' '
	Do i=1 for Dll_list.0
	   call query_handle
	End
	Say ' '
	Say '   DLL(s) query handle done'
	Say ' '
	Say '   note 1: Found = at least, modules where loaded one time post boot'
	Say '   note 2: Found = Module may be loaded or not (freed)'
	Say ' '
        return
End

/* --------------a few variables ------------ */
CRLFEOFtag = x2c("0D0A")
tagcr	   = x2c("0D")
taglf	   = x2c("0A")
rcfailed   = 0
outfile    = '~ffmpegH'
Hndfile    = ''
rcerror    =''
/* ------------------------------------------ */
/* fulllog from cmd line or forced here 1 | 0 */ 
/* fulllog = 1                                */ 
/* ------------------------------------------ */
DLLhnd.0   =0

If stream(outfile,'c','query exist')\='' then do
	If option='-l' then ''||'@erase '||outfile
	Else do
	    If (single_dll='')&(pos('.DLH',translate(single_dll))=0) then do  
		Call readstream
	        If length(Hndfile)>8 then do
		   Hndfile=strip(translate(Hndfile,' ',CRLFEOFtag))
		   Do i=1 to words(Hndfile)
			Vintp=word(hndfile,i)
	                If pos('D',Vintp,1)>1 then Vintp=substr(Vintp,pos('D',Vintp,1))  
			If pos("''",Vintp,1)>0 then do
				Hnd=Substr(Vintp,1,pos("''",Vintp))
				Interpret Hnd
				Hnd=Substr(Vintp,pos("''",Vintp)+2)
				Interpret Hnd
			End			
		      	Else  Interpret Vintp   
		   End   	
		End  
		Say '   Saved Handle file found and '||words(Hndfile)||' lines read'
	    End
	    Else do
		Call readstream
		If Length(Hndfile)>0 then do
		   Hndfile=strip(translate(Hndfile,' ',CRLFEOFtag))
		   If pos(Dll_list.1,Hndfile)>0 then do 
			Vintp=pos(Dll_list.1,Hndfile)-30
			Hpos1=Strip(substr(Hndfile,Vintp,20))   
			If (pos("=",Hpos1)>0)&(pos("''",Hpos1)>0) then do
				hnd=substr(Hpos1,1,pos("''",Hpos1,1)-1)
				hnd=substr(Hnd,pos("=",Hnd,1)+2)
				DLLhnd.1=hnd		
			End
			Else DLLhnd='     '
			Dllhnd.0=Dll_list.0
		   End
	        End
	    End  		 
	End
End
Else do
	Say ' '
	Say '   !Information! no '||outfile||' file found !'
	Say '   (this could be normal at first load request)'
	Say '   ---------------------------------------------------------'

	If (single_dll\='')&(Dll_list.0=1) then do
		rch=RxQueryModuleHandle(Dll_Uhnd,Dll_list.1)
		If rch=0 then do
			Dll_Uhnd.0=1
			If bypass_popup=0 then do
				Say '   ['||Dll_list.1||'] found with handle x"'c2x(Dll_Uhnd)'", load it anyway ?'
				Say '   [Y] to continue - [N] or any other caracter to end'
				Say ' '
				Pull your_answer
				If pos('Y',Translate(your_answer))=0 then exit 4
			End
			Else say '   ['||Dll_list.i||'] with handle x"'c2x(Dll_Uhnd)'" found !, load follows'   	
		End
	End
	If ((single_dll\='')&(Dll_list.0>1))|((option='-u')&(Dll_list.0>1)) then do
	        j=0
                do i=1 for Dll_list.0
			j=j+1
			rch=RxQueryModuleHandle(Dll_Uhnd.j,Dll_list.i)
			If rch=0 then do
				If (bypass_popup=0)&(option='-l') then do
					Call start_messages
					Say ' ' 
					Say '   ['||Dll_list.i||'] found with handle x"'c2x(Dll_Uhnd)'", load it anyway ?'
					Say '   [Y] to confirm - [N] or any other caracter to ignore'
					Say ' '
					Pull your_answer
					If pos('Y',Translate(your_answer))=0 then do
						j=j-1
						Say '   "N" selected, module excluded from load' 	
					End
					Else do 
						Dll_list.j=Dll_list.i
						Say '   "Y" selected, module confirmed'			
					End
					Call syssleep 1/2 	
				End
			        Else do
				If option='-l' then say '   ['||Dll_list.i||'] with handle x"'c2x(Dll_Uhnd.j)'" found !, load follows'
				Else do
					If length(Dll_Uhnd.j)<7 then say '   ['||Dll_list.i||'] with handle x"'c2x(Dll_Uhnd.i)'" found ! bypass popup = Yes'
					Else do
						say '   ['||Dll_list.i||'] with handle x"'c2x(Dll_Uhnd.j)'" invalid ! may be a storage addr '
						say '    -- this handle will be replaced by a dummy one resulting into "free RC99"'
						Dll_Uhnd.i='     '  
					End						
				End
			End   	
		End
		Else do
	      		If option='-u' then do
				Dll_Uhnd.j='     '
				say '   No query handle found for DLL: '||Dll_list.i||' -  an RC99 will be set fo this DLL on free'    
			End
		End
		Dll_Uhnd.j=c2x(Dll_Uhnd.j)
                        End
	        If option="-l" then Dll_list.0=j 	
	        Dll_Uhnd.0=j
	        say '   End of dynamic handle acquisition (query), process continues...'
	        say ' '  	   	
	End
End
   
/* End */

Select
	When option='-l' then do
		dlln=0
		Do i=1 for Dll_list.0
			Call query_handle
			rch=RxLoadModule(DLLhnd.i,Dll_list.i)
  			If rch<>0 then do
				Call check_rch
				rchmod=''
				say '   -  Error during load request of "'||Dll_list.i||'" rc:'||rch
				rcfailed=rcfailed+1
   			End
			Else do
				Say '   >> Module "'||Dll_list.i||'" successuffly loaded'
				dlln=dlln+1 
				Hndfile=Hndfile||"DLLhnd."||dlln||"='"||c2x(DLLhnd.i)||"''"||"Dll_list."||dlln||"='"||Dll_list.i||"'"||CRLFEOFtag
			End
			If fulllog=1 then Call load_error_codes
		End
		Hndfile="DLLhnd.0='"||dlln||"'"||CRLFEOFtag||Hndfile
	End 	
	When option='-u' then do
	    If Dll_Uhnd.0 > 0 then do 	
		Do i=1 for Dll_Uhnd.0
			Dll_Uhnd.i = x2c(Dll_Uhnd.i)
			If Dll_Uhnd.i='     ' then rch=99	
			Else rch=RxFreeModule(Dll_Uhnd.i)
   			If rch<>0 then do
				Call check_rch
				If rch=99 then say '   -  Error during free of module handle x"'||'        '||'" (rc:'||rch||' - '||Dll_list.i||')'rchmod
				Else say '   -  Error during free of module handle x"'||c2x(Dll_Uhnd.i)||'" (rc:'||rch||' - '||Dll_list.i||')'rchmod
				rcfailed=rcfailed+1
			End
			Else do
				say '   >> module with handle x"'||c2x(Dll_Uhnd.i)||'" successfully freed (rc:'||rch||' - '||Dll_list.i||')'
			End
			If fulllog=1 then Call free_error_codes
   		End
		If Dll_Uhnd.0 = 0 then say '   *WARNING* No DLL query "handle" found to proceed, free aborted'   	
	    End
	    Else do 
		Do i=1 for DLLhnd.0
			Dllhnd.i=x2c(DLLhnd.i)
	 		rch=RxFreeModule(DLLhnd.i)
   			If rch<>0 then do
				Call check_rch	
				say '   -  Error during free of module handle x"'||c2x(DLLhnd.i)||'" (rc:'||rch||' - '||Dll_list.i||')'rchmod
				rcfailed=rcfailed+1
			End
			Else do
				say '   >> module with handle x"'||c2x(DLLhnd.i)||'" successfully freed (rc:'||rch||' - '||Dll_list.i||')'
			End
			If fulllog=1 then Call free_error_codes
   		End
		If DLLhnd.0 = 0 then say '   *WARNING* No DLL "handle" found to proceed, free aborted'
	    End   	
	End
	When option='!' then do
		Do i=1 to Dll_list.0
			''||'unlock '||Dll_list.j||'.dll'
		End
	End
	Otherwise
	rcfailed='-1'
	Say '   Invalid option specified !'
	Say ' '
	Call help_messages
        Say ' '  
        Say '   Try again...'
End

If (length(Hndfile)>8)&(option='-l') then do
	Call STREAM outfile,'c','open write'
	rc=CHAROUT(outfile,Hndfile)
	If rc>0 then do
		Say '   *WARNING* handle output file not created !'
		Say '   (you may not be able to free storage using this file but use an external *.dlh file)'
	End   
	Call STREAM outfile,'c','close'
End
If rcfailed>0 then do
	Say ' '
	Select
		when option='-l' then do
			Say '   Successfully loaded DLLs : '||Dll_list.0-rcfailed||', expected : '||Dll_list.0
			Call closing_messages
		End      
		when (option='-u')&(Dll_Uhnd.0>0) then Say '   Successfully freed  DLLs : '||Dll_Uhnd.0-rcfailed||', expected : '||Dll_Uhnd.0
		when option='-u' then Say '   Successfully freed  DLLs : '||DLLhnd.0-rcfailed||', expected : '||DLLhnd.0
		otherwise nop
	End  
	If option='-l'then say '   Not loaded count : '||rcfailed
	Else say '   Not freed count : '||rcfailed
	Say ' '  
End	
Else do
	Say ' '
	If rcfailed<0 then say 'Process ended without action !'
	Else do
	   Select
		when option='-l' then do
			say '   Load of '||Dll_list.0||' DLLs successfull'
			say '   (ps:under test mode, wait a few seconds before trying the "free" option)'
			Call closing_messages
		End
		when (option='-u')&(single_dll\='') then do
			If Dll_list.0>0 then say '   handle found for DLLs input file "'||single_dll||'" and DLLs successfully freed'
			Else '   handle found for "'||Dll_list.1||'" and DLLs successfully freed'
		End
		when option='-u' then do
			say '   Free of '||DLLhnd.0||' DLLs successfull'
		End
		Otherwise nop
	   End  
	End
	Say ' '
End
Return


Check_rch:
rchmod=''
If words(rch)>1 then do
	rchmod=word(rch,2)
	rch=word(rch,1)
End
Else rchmod=''
Return


readstream:
fsize=stream(outfile,'c','query size')
Call STREAM outfile,'c','open read'
Hndfile=CHARIN(outfile,1,fsize)
Call STREAM outfile,'c','close'
Return

Read_dll_file:
CRLFEOFtag = x2c("0D0A")
fsize=stream(single_dll,'c','query size')
Call STREAM single_dll,'c','open read'
dllfile=CHARIN(single_dll,1,fsize)
Call STREAM single_dll,'c','close'
If length(dllfile)>0 then do
   Uhnd=0;drop Dll_Uhnd.;dll_path=''
   dllfile=strip(translate(dllfile,'  ',CRLFEOFtag))
   If pos('"',dllfile,1)=1 then do 
	drop abort_load;abort_load=0
	dll_path=substr(dllfile,1,pos('"',dllfile,4))
	dllfile=substr(dllfile,pos('"',dllfile,4)+1)
	Say '   Dll(s) path : '||dll_path
	dll_path=strip(translate(dll_path,' \','"/'))
	If lastpos('\',dll_path)=length(dll_path) then dll_path=substr(dll_path,1,length(dll_path)-1)
	path_pgm = directory()
	new_ffmpegdir = directory(dll_path)
        If new_ffmpegdir = strip(translate(dll_path,' ','"')) then Say '   Path to DLL(s) found, process will continue and try loading DLL(s)'
        Else do
		Say "   Can't find the speficfied path : "||new_ffmpegdir||'!. Aborting process...'  
		abort_load=1
		Call directory path_pgm
	End	
   End
   Dll_list.0=words(dllfile)
   Do i=1 for words(dllfile)
      Uhnd=Uhnd+1	
      wdlh=word(dllfile,i) 	
      If pos('.DLL',translate(wdlh),1)>0 then Dll_list.i=substr(wdlh,1,pos('.DLL',translate(wdlh),1)-1)
      Else Dll_list.i=word(dllfile,i)
      rch=RxQueryModuleHandle(Dll_Uhnd.i,Dll_list.i)
      If rch<>0 then Dll_Uhnd.i=c2x('      ')
      Else Dll_Uhnd.i = c2x(Dll_Uhnd.i)
      Dll_Uhnd.0=Uhnd	
   End   
End  
Return

Query_handle:
drop test_handle; drop test_module;drop end_string
If option\='-q' then end_string='before load'
Else end_string=''
rch=RxQueryModuleHandle(test_handle,Dll_list.i)
If rch=0 then do 
	rcm=RxQueryModuleName(test_module,test_handle)
	Say '   *Information* found module with handle x"'||c2x(test_handle)||'" '||end_string
	If length(test_module)>70 then do
		test_module1='['||length(test_module)||'] '||substr(test_module,1,45)||'.......'||substr(test_module,length(test_module)-13);test_module=test_module1
	End
	Say '    ['||test_module||']'
End
Else do
	If (option='-q')&(fulllog=1) then do
		rcerror=''
		Call load_error_codes
		If rcerror\='' then do
			say '   No handle for '||Dll_list.i||' ['||rch||']'
			say '   ['||rcerror||']'
		End
	End
	Else say '   No handle for '||Dll_list.i||' ['||rch||']'
End 
Return

load_error_codes:
Select
when rch=0 then rcerror='NO_ERROR'
when rch=2 then rcerror='ERROR_FILE_NOT_FOUND'
when rch=3 then rcerror='ERROR_PATH_NOT_FOUND'
when rch=4 then rcerror='ERROR_TOO_MANY_OPEN_FILES'
when rch=5 then rcerror='ERROR_ACCESS_DENIED'
when rch=8 then rcerror='ERROR_NOT_ENOUGH_MEMORY'
when rch=11 then rcerror='ERROR_BAD_FORMAT'
when rch=26 then rcerror='ERROR_NOT_DOS_DISK'
when rch=32 then rcerror='ERROR_SHARING_VIOLATION'
when rch=33 then rcerror='ERROR_LOCK_VIOLATION'
when rch=36 then rcerror='ERROR_SHARING_BUFFER_EXCEEDED'
when rch=95 then rcerror='ERROR_INTERRUPT'
when rch=108 then rcerror='ERROR_DRIVE_LOCKED'
when rch=123 then rcerror='ERROR_INVALID_NAME'
when rch=126 then rcerror='ERROR_CODE_126_NOT_FOUND'
when rch=127 then rcerror='ERROR_PROC_NOT_FOUND'
when rch=180 then rcerror='ERROR_INVALID_SEGMENT_NUMBER'
when rch=182 then rcerror='ERROR_INVALID_ORDINAL'
when rch=190 then rcerror='ERROR_INVALID_MODULETYPE'
when rch=191 then rcerror='ERROR_INVALID_EXE_SIGNATURE'
when rch=192 then rcerror='ERROR_EXE_MARKED_INVALID'
when rch=194 then rcerror='ERROR_ITERATED_DATA_EXCEEDS_64K'
when rch=195 then rcerror='ERROR_INVALID_MINALLOCSIZE'
when rch=196 then rcerror='ERROR_DYNLINK_FROM_INVALID_RING'
when rch=198 then rcerror='ERROR_INVALID_SEGDPL'
when rch=199 then rcerror='ERROR_AUTODATASEG_EXCEEDS_64K'
when rch=201 then rcerror='ERROR_RELOCSRC_CHAIN_EXCEEDS_SEGLIMIT'
when rch=206 then rcerror='ERROR_FILENAME_EXCED_RANGE'
when rch=295 then rcerror='ERROR_INIT_ROUTINE_FAILED'
otherwise rcerror=''
End
If rcerror\='' then say '   -  detail: ['||rcerror||']' 
Return

free_error_codes:
select
when rch=0 then rcerror='NO_ERROR'
when rch=6 then rcerror='ERROR_INVALID_HANDLE'
when rch=12 then rcerror='ERROR_INVALID_ACCESS'
when rch=95 then rcerror='ERROR_INTERRUPT'
When rch=99 then rcerror='ERROR_NO_HANDLE_FOUND'
othrwise rcerror=''
End
If rcerror\='' then say '   -  detail: ['||rcerror||']' 
Return

start_messages:
''||'@cls'
Say '     Running ffmpeg (and more) permanent DDLs load into memory   '
Say '   ( note1: load / free works for below or above 512MB line     )'
Say '   ( note2: DLLs loaded into HIGH SHR is permanent until "free" )'
Say ' '  
say '   Processing... with options : '||option||' '||single_dll||' '||fulllog
say '  '
Return

help_messages:
say '   ffmpeghigh/ffmpegh REXX for loading permanently DLL(s) mostly in high SHR'
say '   Version 0.9.1 (batch) and version 0.4 (exe buid) - same rexx code level'
say '   Remy Dodin <remydodin dot levillage dot org>'
say '   The tool is declined as batch file or exe usable from startup folder'
say ' '
say '   usage: ffmpeghigh [-option] {blanlk/dll module/file(dll list)} [detail]'
say '   without options, nothing happens'
say '   Type of entry'
say '   - empty (blank) input uses internal declared DDL(s) for ffmpeg' 
say '   - a dll name (xxxx.dll)'
say '   - a full dll path'
say '   - a file with an optionnal path between " and a dll list "dir *.dll >b-d"'    
say '   Options:'  
say '      -l  load DLL(s). Loaded DLL ramin loaded until this program is closes'
say '      -u  free DLL(s). You can free DLL memory locations previously loaded'
say '      -q  query DLL(s). Check if a DLL has a handle (is or was loaded)'
say '      -!  will call unlock to unlock DLL(s) ** depreciated **'
say '   -? -h  This help'
say '   Detail: only possible value of 1 (display more information about RC'
Return

closing_messages:
Say ' ' 
Say ' *WARNING* Do not close this "prompt window dialog" to maintain DLL(s) loaded'
Say '           And gain benefits of permanent loaded DLL(s) used by applications'
Say '           >> Closing this window will free loaded DLL(s) through this tool <<'
Say ' '
return

closing_message2:
Say '  R.Dodin 2020 - Use this tool at you own risc and assume all problems which'
say "                 could happen. Of course, if you do not agree, don't use my"
say '                 private tool'     
Say '  '                         
Return